//--------------- README -----------------
//
// This patch fixes a bug with Scipad:
// Scipad wasn't able to save files under specials directories ( C:\Documents and Settings, ... ) under Windows platforms.
// 
// Use this patch only if you have installed Scilab from scilab-3.1.1.exe.
// 
// To install this patch :
// 	
// 	1. download and unzip scilab-3.1.1-patch-a.zip somewhere (<patch-dir>).
// 	
// 	
// 	2. Into the scilab console, enter the following command:
// 		exec "<patch-dir>\patch-3.1.1.sce";
// 		
// 	   or
// 	   
// 	    ( Only if *.sce files are associated with scilab-3.1.1)
// 	    Click right on the file "patch-3.1.1.sce" and select "Execute".
// 					
// 	 
// => The patch is installed !
// 
// 
// Note that the patch is included in the CVS version.
// 
//
//-----------------------------------------------

//-----------------------------------------------
// Allan CORNET INRIA 2005
// Patch for Scilab 3.1.1 (scipad)
//-----------------------------------------------

function PatchFilecommandsTcl()
 global LANGUAGE
 stringpatch='# Patch 3.1.1 Bug writesav';
 
 patchtcl=['proc writesave {textarea nametosave} {';
'# generic save function - write a file onto disk';
'    global listoffile';
'    # if the file exists, check once more if the file is writable ';
'    # if it doesn''t, check if the directory is writable';
'    # (case of Save as...) (non existent files return 0 to writable)';
'    if {[file exists $nametosave]} {';
'        set listoffile(""$textarea"",readonly) \';
'          [expr [file writable $nametosave] == 0]';
'    } else {';
'	set listoffile(""$textarea"",readonly) 0';
'	# To fix the Windows bad behavior when wanting to write a ';
'	# file in an exotic directory where read-only is set';
'    }';
' ';
'    if {$listoffile(""$textarea"",readonly)==0} {';
'        set FileNameToSave [open $nametosave w+]';
'        puts -nonewline $FileNameToSave [$textarea get 0.0 end]';
'        close $FileNameToSave';
'        unsetmodified $textarea';
'        set listoffile(""$textarea"",thetime) [file mtime $nametosave] ';
'        set msgWait [concat [mc ""File""] $nametosave [mc ""saved""]]';
'        showinfo $msgWait';
' ';
'	#test if file creation has succeeded';
'	if {![file exists $nametosave]} {';
'	    set msgWait [concat $nametosave [mc ""cannot be written!""]]';
'	    tk_messageBox -message $msgWait';
'	    filesaveas $textarea';
'    	}';
'    } else {';
'        set msgWait [concat $nametosave [mc ""cannot be written!""]]';
'        tk_messageBox -message $msgWait';
'        filesaveas $textarea';
'    }';
'}']

 filetcl=mgetl(SCI+'\tcl\scipadsources\filecommands.tcl');
  
 if filetcl(1)==stringpatch then 
  if (LANGUAGE=='fr') then
    disp('Mise  jour dj effectue');
  else
    disp('Already patched.');
  end
 else
  if (size(filetcl)==[878,1]) then
  
    mputl(filetcl,SCI+'\tcl\scipadsources\filecommands.old'); 
    
    Newfiletcl=[stringpatch;filetcl(1:494);patchtcl;filetcl(522:878)];
    mputl(Newfiletcl,SCI+'\tcl\scipadsources\filecommands.tcl');
    
    if (LANGUAGE=='fr') then
      disp('Scilab a t correctement mis  jour.');
      disp('Veuillez fermer Scilab.');
    else
      disp('Scilab was successfully updated.');
      disp('Please Close all your Scilab.');
    end
  else
    if (LANGUAGE=='fr') then
      disp('fichier filecommands.tcl incorrect.');
    else
      disp('incorrect filecommands.tcl');
    end
  end
 end
endfunction
//-----------------------------------------------
global LANGUAGE
if MSDOS then
  [ver,infover]=getversion();
  if (ver=='scilab-3.1.1') & (infover(8)=='May 31 2005') & (infover(9)=='10:14:15') then
    PatchFilecommandsTcl();
  else
   if (LANGUAGE=='fr') then
     disp('Seulement pour la version binaire officielle de Scilab 3.1.1.'); 
   else
     disp('Only for Scilab 3.1.1 Binary from scilab Web Site.');
   end
  end 
else
  if (LANGUAGE=='fr') then
    disp('Correctif seulement pour Scilab 3.1.1 (Windows).');
  else
    disp('Windows Only.');
  end
end
//-----------------------------------------------
